"""
///
/// b_ming.py
///
/// Author:
///   Woo-Kyoung Noh (rainlood@kldp.org)
///
/// (C) 2001 Woo-Kyoung Noh  http://gnome.or.kr/~rainlood/
///
///
///
///
/// <summary>
/// boinda ming
/// </summary>
"""

from ming import *
from tempfile import TemporaryFile
import string


RED = (0xff,0x00,0x00)
WHITE = (0xff,0xff,0xff)
BLACK = (0x00,0x00,0x00)

def rect(r, g, b):
  s = SWFShape()
  s.setRightFill(s.addFill(r, g, b))
  s.drawLine(600,0)
  s.drawLine(0,600)
  s.drawLine(-600,0)
  s.drawLine(0,-600)
  return s

class BoindaMingHtml(SWFSprite):
	def __init__(self, **args):
		SWFSprite.__init__(self)

		s3 = SWFTextField()#SWFTEXTFIELD_NOEDIT)
		s3.setBounds(2040, 263)
		s3.setFont(SWFFont('_serif'))
		s3.setHeight(200)
		s3.setColor(0x00,0x00,0x00,0xff)
		#s3.addString(r'<font size="10">test</font>')
		s3.addString('test')
		s3.setVariableName('status') 
		self.add(s3)
		b = SWFButton()
		b.addShape(rect(0xff, 0, 0), SWFBUTTON_UP | SWFBUTTON_HIT)
		b.addShape(rect(0, 0xff, 0), SWFBUTTON_OVER)
		b.addShape(rect(0, 0, 0xff), SWFBUTTON_DOWN)

		b.addAction(SWFAction('''
status = "fasjdlkjfdwsjlkdasjf<b>test</b>";
'''), SWFBUTTON_MOUSEUP)
		self.add(b)
		self.nextFrame()

class BoindaMing:
	def __init__(self):
		movie = SWFMovie()
		movie.setRate(12.000000)
		movie.setDimension(11000, 8000)
		movie.setFrames(1)
		movie.setBackground(0xff,0xff,0xff)
		self.movie = movie
		self.items = []

	def addInstance(self, instance):
		i=self.movie.add(instance)
		#i.moveTo(686, 493)
		self.items += [i]

	def getMovie(self):
		f = TemporaryFile()
		self.movie.saveToFile(f)
		f.seek(0)
		data = f.read()
		f.close()
		return data

ming = BoindaMing()
bmHtml = BoindaMingHtml()
ming.addInstance(bmHtml)
#test
#<a href="kldp.org">kldp.org</a>
#"""
#data=string.replace(data, '"', r'\"')
#ming.movie.add(SWFAction('status="'+data+'";'))
m = ming.getMovie()
f=open('test.swf','w')
f.write(m)
f.close()

if __name__ == '__main__':
	from b_test import unittest, BoindaTest
	class BoindaMingTestCase(unittest.TestCase):
		def setUp(self):
			self.ming = BoindaMing()

		def checkEqual(self):
			assert 1==1

	BoindaTest ( BoindaMingTestCase )
