"""
///
/// b_soap.py
///
/// Author:
///   Woo-Kyoung Noh (rainlood@kldp.org)
///
/// (C) 2001 Woo-Kyoung Noh  http://gnome.or.kr/~rainlood/
///
///
///
///
/// <summary>
/// boinda soap
/// </summary>
"""

import sys 
import SOAP

from b_index import BoindaIndex
from b_setup import BOINDA_SYSTEMROOT
from b_setup import BOINDA_SERVER_HOST, BOINDA_SERVER_PORT
from b_setup import BOINDA_ONTEST

if BOINDA_ONTEST:
	SOAP.Config.debug = 1



def dog():
	return 'mong'

def cat():
	return 'ya ong'

# methods to register
methods = (dog, cat, )




class BoindaSoap:
	def __init__(self):
		self.funcmap = {}
		self.namespace = None
		for method in methods:
			self.registerFunction(method)

	def registerFunction(self, function, namespace = '', funcName = None):
		if not funcName : funcName = function.__name__
		if namespace == '': namespace = self.namespace
		if self.funcmap.has_key(namespace):
			self.funcmap[namespace][funcName] = function
		else:
			self.funcmap[namespace] = {funcName : function}

	def parseData(self, data):
		try:
			r, header, body = SOAP.parseSOAPRPC(data, header=1, body=1)
			ns = r._ns
			method = r._name
			args   = r._aslist
			f = self.funcmap[ns][method]
			fr = apply(f,args,{})
			resp = SOAP.buildSOAP(kw = {'%sResponse' % method:{'Result':fr}}, )#
#		except TypeError, e:
#			resp= SOAP.buildSOAP(SOAP.faultType(e))
		except KeyError, e:
			resp= SOAP.buildSOAP(SOAP.faultType(e))
		return resp


if __name__ == '__main__':
	from b_test import unittest, BoindaTest
	class BoindaSoapTestCase(unittest.TestCase):
		def setUp(self):
			pass

		def checkEqual(self):
			assert 1==1

	if len(sys.argv)==2:
		host=BOINDA_SERVER_HOST
		port=BOINDA_SERVER_PORT
		proxy = SOAP.SOAPProxy("%s:%d"%(host,port))
		try:
			print eval('proxy.%s()'%sys.argv[1])
		except SOAP.faultType, e:
			print e
	else:
		BoindaTest ( BoindaSoapTestCase )
