"""
///
/// b_template.py
///
/// Author:
///   Woo-Kyoung Noh (rainlood@kldp.org)
///
/// (C) 2001 Woo-Kyoung Noh  http://gnome.or.kr/~rainlood/
///
///
///
///
/// <summary>
/// boinda template
/// </summary>
"""

from b_setup import BOINDA_ENABLE_TEMPLATES
from b_setup import BOINDA_MAIN_TITLE



BR='<br/>'
LF='\n'
NBSP='&nbsp;'


class BoindaTemplate:
	def boinda_template(self):
		r=''
		r=r+'<html>'
		for item in self.location:
			if item('url')==self.env.sWebRoot:
				title=BOINDA_MAIN_TITLE
			else:
				title = item('title')
			r=r+item('url', title=title, on=('a',), env=self.env)
			r=r+NBSP*2
		r=r+BR*2
		r=r+'<pre>'
		for item in self.content:
			title = item('title')
			icon = item('icon')
			r=r+item('url', title=title, icon=icon, on=('a','b','img','exist'), env=self.env)
			r=r+item('desc', on=('link',))
			r=r+LF
			r=r+LF
		r=r+'</pre>'
		r=r+'</html>'
		return r

	def __init__(self, env, location, content, sTemplate):
		self.env = env
		self.location = location
		self.content = content
		if BOINDA_ENABLE_TEMPLATES.has_key(sTemplate):
			self.run = eval('self.'+BOINDA_ENABLE_TEMPLATES[sTemplate])
		else:
			self.run = eval('self.'+'boinda_template')
		
	def getResult(self):
		return self.run()



if __name__ == '__main__':
	from b_test import unittest, BoindaTest
	from b_meta import BoindaMeta
	from b_index import BoindaEnv
	class BoindaTemplateTestCase(unittest.TestCase):
		def setUp(self):
			self.template = BoindaTemplate(BoindaEnv(), BoindaMeta(), BoindaMeta(), '')

		def checkEqual(self):
			print self.template.getResult()
			assert 1==1

	BoindaTest ( BoindaTemplateTestCase )
